#!/usr/sbin/dtrace -s
/*
 * lwptime.d: Useful for performance tuning of multi-threaded applications.
 *            Can be used to measure time spent in each individual thread.
 *
 * Usage:     It requires no parameter.
 *
 * Copyright 2007 Sun Microsystems, Inc.,
 * 4150 Network Circle, Santa Clara,
 * California 95054, U.S.A. All rights reserved.
 */
proc:::lwp-create
{
    printf("%s, %d\n", stringof(args[1]->pr_fname), args[0]->pr_lwpid);
}

proc:::lwp-start
/tid != 1/
{
    self->start[tid] = timestamp;
}

proc:::lwp-exit
/self->start[tid]/
{
    @[tid] = sum(timestamp - self->start[tid]);
    self->start[tid] = 0;
}
